﻿import es
import langlib

# ##############################
# ADDON INFORMATION

info = es.AddonInfo()
info.name = "AlBhed"
info.version = "1.1.0"
info.author = "Wonder"
info.basename = "albhed"

# ##############################
# ALBHED-ENGLISH & ENGLISH-ALBHED TRANSLATIONS

toLetters = {"a": "e",
	"b": "p",
	"c": "s",
	"d": "t",
	"e": "i",
	"f": "w",
	"g": "k",
	"h": "n",
	"i": "u",
	"j": "v",
	"k": "g",
	"l": "c",
	"m": "l",
	"n": "r",
	"o": "y",
	"p": "b",
	"q": "x",
	"r": "h",
	"s": "m",
	"t": "d",
	"u": "o",
	"v": "f",
	"w": "z",
	"x": "q",
	"y": "a",
	"z": "j",
	# Upper-case
	"A": "E",
	"B": "P",
	"C": "S",
	"D": "T",
	"E": "I",
	"F": "W",
	"G": "K",
	"H": "N",
	"I": "U",
	"J": "V",
	"K": "G",
	"L": "C",
	"M": "L",
	"N": "R",
	"O": "Y",
	"P": "B",
	"Q": "X",
	"R": "H",
	"S": "M",
	"T": "D",
	"U": "O",
	"V": "F",
	"W": "Z",
	"X": "Q",
	"Y": "A",
	"Z": "J"}

fromLetters = {"e": "a",
	"p": "b",
	"s": "c",
	"t": "d",
	"i": "e",
	"w": "f",
	"k": "g",
	"n": "h",
	"u": "i",
	"v": "j",
	"g": "k",
	"c": "l",
	"l": "m",
	"r": "n",
	"y": "o",
	"b": "p",
	"x": "q",
	"h": "r",
	"m": "s",
	"d": "t",
	"o": "u",
	"f": "v",
	"z": "w",
	"q": "x",
	"a": "y",
	"j": "z",
	# Upper-case
	"E": "A",
	"P": "B",
	"S": "C",
	"T": "D",
	"I": "E",
	"W": "F",
	"K": "G",
	"N": "H",
	"U": "I",
	"V": "J",
	"G": "K",
	"C": "L",
	"L": "M",
	"R": "N",
	"Y": "O",
	"B": "P",
	"X": "Q",
	"H": "R",
	"M": "S",
	"D": "T",
	"O": "U",
	"F": "V",
	"Z": "W",
	"Q": "X",
	"A": "Y",
	"J": "Z"}


# ##############################
# SERVER VARIABLES
variables = {"version": (info.version, "Holds the major, minor and revision version numbers of AlBhed."),
	"tocmd": ("!toAlBhed", "The command used in chat to translate _ENGLISH_ text into AlBhed."),
	"fromcmd": ("!fromAlBhed", "The command used in chat to translate AlBhed into _ENGLISH_ text.")}

# ##############################
# REST OF THE ADDON
def load():
	"""
	Initializes server variables and prepares the server.
	"""
	global text

	# Initialize server variables.
	for variable, (value, brief) in variables.iteritems():
		es.ServerVar("albhed_" + variable, value, brief)
	es.makepublic("albhed_version")

	es.addons.registerSayFilter(sayFilter)
	text = langlib.Strings(es.getAddonPath("albhed") + "/strings.ini")

def unload():
	"""
	Called when the addon is being unloaded.
	"""
	es.addons.unregisterSayFilter(sayFilter)

def sayFilter(userid, message, teamonly):
	"""
	Will translate to/from AlBhed when special commands are used.
	"""
	# If quotes are the first and last characters, remove them.
	inQuotes = False
	if (message[0] == '"') and (message[-1:] == '"'):
		inQuotes = True
		message = message[1:-1]

	if message[:len(toCmd) + 1].lower() == (toCmd.lower() + " "):
		message = message[len(toCmd) + 1:]
		inBrackets = False
		newMessage = ""

		for i in message:
			if (i == "[") and not inBrackets:
				inBrackets = True
				continue
			if (i == "]") and inBrackets:
				inBrackets = False
				continue
			if (i in toLetters) and not inBrackets:
				newMessage += toLetters[i]
			else:
				newMessage += i

		return (userid, newMessage, teamonly)
	elif message[:len(fromCmd) + 1].lower() == (fromCmd.lower() + " "):
		message = message[len(fromCmd) + 1:]
		inBrackets = False
		newMessage = ""

		for i in message:
			if (i == "[") and not inBrackets:
				inBrackets = True
				continue
			if (i == "]") and inBrackets:
				inBrackets = False
				continue
			if (i in fromLetters) and not inBrackets:
				newMessage += fromLetters[i]
			else:
				newMessage += i

		return (userid, newMessage, teamonly)

	# If the text was wrapped in quotes, send it back that way.
	if inQuotes:
		return (userid, '"' + message + '"', teamonly)
	return (userid, message, teamonly)

def round_start(eventVar):
	"""
	Informs players on the server on how to translate text to/from AlBhed.
	"""
	es.msg("#multi", "#greenAlBhed#default: " + text("round_start", {"toCmd": toCmd, "fromCmd": fromCmd}))
